{ ****************************************************************** }
{                                                                    }
{   VCL component TTabularLoad                                       }
{                                                                    }
{   Code generated by Component Create for Delphi                    }
{                                                                    }
{   Generated from untitled component definition                     }
{   on 8 May 2000 at 13:12                                           }
{                                                                    }
{   Copyright  2000 by Daaron Dwyer                                 }
{                                                                    }
{ ****************************************************************** }

unit Tabload;

interface

uses WinTypes, WinProcs, Messages, SysUtils, Classes, Controls, 
     Forms, Graphics, Db, Grids;

type
  TNewColKeyEvent = procedure (Sender : TObject; Col : Integer; var Data : String) of object;

  TNewRowKeyEvent = procedure (Sender : TObject; Row : Integer; var Data : String) of object;

  TSetCellDataEvent = procedure (Sender : TObject; Row, Col : Integer; var Data : String) of object;

  TTabularLoad = class(TComponent)
    private
      { Private fields of TTabularLoad }
        FColFieldIndex : Integer;
        FColFieldKeys : TStrings;
        FDataFieldIndex : Integer;
        FDataSource : TDataSource;
        fGrid : TStringGrid;
        FRowFieldIndex : Integer;
        FRowFieldKeys : TStrings;
        { Pointer to application's OnAfterProcess handler, if any }
        FOnAfterProcess : TNotifyEvent;
        { Pointer to application's OnBeforeProcess handler, if any }
        FOnBeforeProcess : TNotifyEvent;
        { Pointer to application's OnNewColKey handler, if any }
        FOnNewColKey : TNewColKeyEvent;
        { Pointer to application's OnNewRowKey handler, if any }
        FOnNewRowKey : TNewRowKeyEvent;
        { Pointer to application's OnSetCellData handler, if any }
        FOnSetCellData : TSetCellDataEvent;

      { Private methods of TTabularLoad }
        { Method to set variable and property values and create objects }
        procedure AutoInitialize;
        { Method to free any objects created by AutoInitialize }
        procedure AutoDestroy;
        procedure SetColFieldKeys(Value : TStrings);
        procedure SetRowFieldIndex(Value : Integer);
        procedure SetRowFieldKeys(Value : TStrings);

    protected
      { Protected fields of TTabularLoad }

      { Protected methods of TTabularLoad }
        { Resets prop of component type if referenced component deleted }
        procedure Notification(AComponent : TComponent; Operation : TOperation); override;
        { Method to generate OnAfterProcess event }
        procedure AfterProcess(Sender : TObject); virtual;
        { Method to generate OnBeforeProcess event }
        procedure BeforeProcess(Sender : TObject); virtual;
        { Method to generate OnNewColKey event }
        procedure NewColKey(Sender : TObject; Col : Integer; var Data : String); virtual;
        { Method to generate OnNewRowKey event }
        procedure NewRowKey(Sender : TObject; Row : Integer; var Data : String); virtual;
        { Method to generate OnSetCellData event }
        procedure SetCellData(Sender : TObject; Row, Col : Integer; var Data : String); virtual;
        procedure Loaded; override;

    public
      { Public fields and properties of TTabularLoad }

      { Public methods of TTabularLoad }
        constructor Create(AOwner: TComponent); override;
        destructor Destroy; override;
        procedure Execute;

    published
      { Published properties of TTabularLoad }
        property OnAfterProcess : TNotifyEvent read FOnAfterProcess write FOnAfterProcess;
        property OnBeforeProcess : TNotifyEvent read FOnBeforeProcess write FOnBeforeProcess;
        property OnNewColKey : TNewColKeyEvent read FOnNewColKey write FOnNewColKey;
        property OnNewRowKey : TNewRowKeyEvent read FOnNewRowKey write FOnNewRowKey;
        property OnSetCellData : TSetCellDataEvent read FOnSetCellData write FOnSetCellData;
        property ColFieldIndex : Integer read FColFieldIndex write FColFieldIndex;
        property ColFieldKeys : TStrings read FColFieldKeys write SetColFieldKeys;
        property DataFieldIndex : Integer read FDataFieldIndex write FDataFieldIndex;
        property DataSource : TDataSource read FDataSource write FDataSource;
        property Grid : TStringGrid read fGrid write fGrid;
        property RowFieldIndex : Integer read FRowFieldIndex write SetRowFieldIndex;
        property RowFieldKeys : TStrings read FRowFieldKeys write SetRowFieldKeys;

  end;

procedure Register;

implementation

procedure Register;
begin
     { Register TTabularLoad with Samples as its
       default page on the Delphi component palette }
     RegisterComponents('Samples', [TTabularLoad]);
end;

{ Method to set variable and property values and create objects }
procedure TTabularLoad.AutoInitialize;
begin
     FColFieldKeys := TStringList.Create;
     FDataSource := nil;
     FGrid := nil;
     FRowFieldKeys := TStringList.Create;
end; { of AutoInitialize }

{ Resets prop of component type if referenced component deleted }
procedure TTabularLoad.Notification(AComponent : TComponent; Operation : TOperation);
begin
     inherited Notification(AComponent, Operation);
     if Operation <> opRemove then
        Exit;
     { Has a component referenced by a property of 
       this component been deleted?  If so, update 
       the property. }
     if AComponent = FDataSource then
        FDataSource := nil;
     if AComponent = FGrid then
        FGrid := nil;
end;

{ Method to free any objects created by AutoInitialize }
procedure TTabularLoad.AutoDestroy;
begin
     FColFieldKeys.Free;
     FRowFieldKeys.Free;
end; { of AutoDestroy }

procedure TTabularLoad.SetColFieldKeys(Value : TStrings);
begin
     { Use Assign method because TStrings is an object type
       and FColFieldKeys has been created. }
     FColFieldKeys.Assign(Value);
end;

procedure TTabularLoad.SetRowFieldIndex(Value : Integer);
begin
     FRowFieldIndex := Value;
end;

procedure TTabularLoad.SetRowFieldKeys(Value : TStrings);
begin
     { Use Assign method because TStrings is an object type
       and FRowFieldKeys has been created. }
     FRowFieldKeys.Assign(Value);
end;

{ Method to generate OnAfterProcess event }
procedure TTabularLoad.AfterProcess(Sender : TObject);
begin
     { Has the application assigned a method to the event, whether
       via the Object Inspector or a run-time assignment?  If so,
       execute that method }
     if Assigned(FOnAfterProcess) then
        FOnAfterProcess(Sender);
end;

{ Method to generate OnBeforeProcess event }
procedure TTabularLoad.BeforeProcess(Sender : TObject);
begin
     { Has the application assigned a method to the event, whether
       via the Object Inspector or a run-time assignment?  If so,
       execute that method }
     if Assigned(FOnBeforeProcess) then
        FOnBeforeProcess(Sender);
end;

{ Method to generate OnNewColKey event }
procedure TTabularLoad.NewColKey(Sender : TObject; Col : Integer; var Data : String);
begin
     { Has the application assigned a method to the event, whether
       via the Object Inspector or a run-time assignment?  If so,
       execute that method }
     if Assigned(FOnNewColKey) then
        FOnNewColKey(Sender, Col, Data);
end;

{ Method to generate OnNewRowKey event }
procedure TTabularLoad.NewRowKey(Sender : TObject; Row : Integer; var Data : String);
begin
     { Has the application assigned a method to the event, whether
       via the Object Inspector or a run-time assignment?  If so,
       execute that method }
     if Assigned(FOnNewRowKey) then
        FOnNewRowKey(Sender, Row, Data);
end;

{ Method to generate OnSetCellData event }
procedure TTabularLoad.SetCellData(Sender : TObject; Row, Col : Integer; var Data : String);
begin
     { Has the application assigned a method to the event, whether
       via the Object Inspector or a run-time assignment?  If so,
       execute that method }
     if Assigned(FOnSetCellData) then
        FOnSetCellData(Sender, Row, Col, Data);
end;

constructor TTabularLoad.Create(AOwner: TComponent);
begin
     inherited Create(AOwner);
     AutoInitialize;
     
     { Code to perform other tasks when the component is created }
     
end;

destructor TTabularLoad.Destroy;
begin
     AutoDestroy;
     inherited Destroy;
end;

procedure TTabularLoad.Execute;
var
   row, col, data : string;
   rowidx, colidx : integer;
   newRow, newCol : Boolean;
begin
     if not fDataSource.DataSet.Active then
        raise EComponentError.Create('DataSet is inactive');

     if fDataSource.DataSet.FieldCount-1 < fRowFieldIndex then
        raise EComponentError.Create('Row field index exceeds DataSet field count');
     if fDataSource.DataSet.FieldCount-1 < fColFieldIndex then
        raise EComponentError.Create('Column field index exceeds DataSet field count');
     if fDataSource.DataSet.FieldCount-1 < fDataFieldIndex then
        raise EComponentError.Create('Data field index exceeds DataSet field count');

     newRow := FALSE;
     newCol := FALSE;

     fRowFieldKeys.Clear;
     fColFieldKeys.Clear;

     fRowFieldKeys.add('');
     fColFieldKeys.add('');

     fDataSource.DataSet.First;
     while not fDataSource.DataSet.EOF do begin
        beforeProcess(self);

        row := fDataSource.DataSet.Fields.Fields[fRowFieldIndex].AsString;
        col := fDataSource.DataSet.Fields.Fields[fColFieldIndex].asString;
        colIdx := fColFieldKeys.indexOf(col);
        rowIdx := fRowFieldKeys.indexOf(row);

        if rowIdx = -1 then begin
           rowIdx := fRowFieldKeys.count;
           NewRowKey(self,rowIdx,row);
           fRowFieldKeys.add(row);
           newRow := TRUE;
           if assigned(fGrid) then fGrid.RowCount := rowIdx+1;
        end;
        
        if colIdx = -1 then begin
           colIdx := fColFieldKeys.count;
           NewColKey(self,colIdx,col);
           fColFieldKeys.add(col);
           newCol := TRUE;
           if assigned(fGrid) then fGrid.ColCount := colIdx+1;
        end;

        if newRow then
           if assigned(fGrid) then fGrid.Cells[0,rowIdx] := row;
        if newCol then
           if assigned(fGrid) then fGrid.Cells[colIdx,0] := col;

        newCol := FALSE;
        newRow := FALSE;

        Data := fDataSource.DataSet.Fields.Fields[FDataFieldIndex].asString;
        SetCellData(self,rowIdx,colIdx,data);

        if assigned(fGrid) then fGrid.Cells[colIdx,rowIdx] := data;

        afterProcess(self);

        fDataSource.DataSet.Next;
     end;
end;

procedure TTabularLoad.Loaded;
begin
     inherited Loaded;

     { Perform any component setup that depends on the property
       values having been set }

end;


end.
